Attribute VB_Name = "Sokoban"
'==================================================================================
'   PROGRAMME BETA D'UN SOKOBAN
'   FRED JUST 1999
'   fredjust@hotmail.com
'   http://fred.just.free.fr/
'       fred.just@free.fr
'==================================================================================




Option Explicit

' Position du joueur dans la grille peut varier qu'entre 0 et 99
'Public Tete As Long

' pour facilite la recherche d'une case dans le tableau
' Briques(x+EnHaut) est la briques situ au juste dessus de la brique x
' Briques(x+2*aDroite) est la briques situ a deux briques a droite de la brique x
Public Const aDroite = 1
Public Const aGauche = -1
Public Const EnBas = 10
Public Const EnHaut = -10

' Code texte pour l'importation des fichiers LEVEL
Public VideTexte As String * 1 ' - par defaut
Public RienTexte As String ' un espace par defaut
Public MurTexte As String * 1 ' # par defaut
Public TrouTexte As String * 1 ' . par defaut
Public TeteTexte As String * 1 ' @ par defaut
Public BoiteTexte As String * 1 ' $ par defaut
Public Trou_TeteTexte As String * 1 ' + par defaut
Public Trou_BoiteTexte As String * 1 ' * par defaut

' Constante pour facilite la recherche du contenu d'une case
Public Const LeVide = -1
Public Const Rien = 0
Public Const Attention = 1
Public Const UnMur = 2
Public Const UnTrou = 4
Public Const UneBoite = 8
Public Const LaTete = 16


Public Type UnCouple
    un As Long ' en fait un index d'une brique
    deux As Long
End Type


Public LigneTexte(9) As String * 10

Public CasePerdanteText As String ' index en string des cases spares par des ;
Public CouplePerdantText As String
'Public TriplePerdantText As String
Public RecordText As String

' seul les briques de 0  99 sont visibles
' le reste est l pour viter les debordements  lors des calculs
' et contient toujours des murs
Public Type UnTableau
    Briques(-10 To 109) As Long
    Emplacement As Collection  'index des cases contenant les trous
    Tete As Long ' index indiquant la position de la tete
    CasePerdant(80) As Long
    CasePerdant_Count As Long
    CouplePerdant(40) As UnCouple
    CouplePerdant_Count As Long
    ReccordMan As Collection  'de string contenant le nom de chaque reccordman
    NbMoveOfReccordMan As Collection  'de string contenant l'historique en string de la partie
    MoveofReccordMan As Collection  'de string contenant l'historique en string de la partie
    TimeOfReccordMan As Collection  ' de long contenant le nombre de seconde pour faire le tableau
    Realisable As Boolean
End Type
        
        ' deux tableaux sont toujours en memoire
        ' pour ne redessiner que le strict necessaire
        ' position du jeu avant le dernier deplacement
Public TableauAvant As UnTableau
        ' position actuel du jeu
Public TableauActuel As UnTableau
        
        
Type UneMaison
    Nom As String
    NbPiece As Long
    PieceVisite As Long
    Piece(15) As UnTableau
End Type
    
'Public TableauTempo As UnTableau

Public LaMaison As UneMaison


' Les cases, les couples et les triplet de briques sont des positions perdantes
' s'il y a une brique sur chaque membre le tableau devient irrealisable



'==================================================================================
'contient chaque coup jou
'h deplacement vers le haut H pousse vers le haut
'de meme pour b et B bas
'               g et G gauche
'               d et D droite


Type UnePartie
    Historique As String
    EnCours As Boolean
    Move As Long
    Debut As Date
    fin As Date
End Type


Public LaPartie As UnePartie

Public THEHOUSE As TextStream

'code touche pour le joueur1
Public KeyCodeHaut As Long
Public KeyCodeBas As Long
Public KeyCodeDroite As Long
Public KeyCodeGauche As Long

'==================================================================================
'   valeur initiale des variables
'==================================================================================
Public Sub InitVariable()
    Dim i As Long
    LaMaison.PieceVisite = 1
    LaMaison.NbPiece = 1
    MurTexte = "#"
    TrouTexte = "."
    TeteTexte = "@"
    BoiteTexte = "$"
    Trou_TeteTexte = "+"
    Trou_BoiteTexte = "*"
    VideTexte = "-"
    RienTexte = " "
    KeyCodeHaut = 104
    KeyCodeBas = 98
    KeyCodeDroite = 102
    KeyCodeGauche = 100
    CasePerdanteText = ""
    CouplePerdantText = ""
    For i = -10 To 109
        TableauAvant.Briques(i) = LeVide
    Next i
End Sub

'==================================================================================
'   test la prescence d'une caisse sur la case
'==================================================================================
Public Function YaBoite(Index As Long) As Boolean
    YaBoite = (TableauActuel.Briques(Index) \ UneBoite = 1)
End Function

'==================================================================================
'   gestion de l'aide
'==================================================================================
Public Sub Allume(Index As Long)
    If TableauActuel.Briques(Index) Mod 2 = 0 Then
        TableauActuel.Briques(Index) = TableauActuel.Briques(Index) + Attention
    End If
End Sub

'==================================================================================
'
'==================================================================================
Public Sub Eteint(Index As Long)
    If TableauActuel.Briques(Index) Mod 2 = 1 Then
        TableauActuel.Briques(Index) = TableauActuel.Briques(Index) - Attention
    End If
End Sub


'==================================================================================
'
'==================================================================================
Public Sub EteintTout(Letableau As UnTableau)
    Dim Index As Long
    For Index = 0 To 99
        If Letableau.Briques(Index) Mod 2 = 1 Then
            Letableau.Briques(Index) = Letableau.Briques(Index) - Attention
        End If
    Next
End Sub

'==================================================================================
'
'==================================================================================
Public Sub EnleveBrique(Letableau As UnTableau)
    Dim Index As Long
    For Index = 0 To 99
        If YaBoite(Index) Then
            Letableau.Briques(Index) = Letableau.Briques(Index) - UneBoite
        End If
    Next
    Letableau.Briques(Letableau.Tete) = Letableau.Briques(Letableau.Tete) - LaTete
End Sub


'==================================================================================
'
'==================================================================================
Public Sub ImportCasesPerdantes(Letableau As UnTableau)
    Dim tempo As String
    Dim i As Long
    
    Letableau.CasePerdant_Count = 0
    i = 1
    While Len(CasePerdanteText) > 1
        tempo = Mid(CasePerdanteText, 1, InStr(1, CasePerdanteText, ";", vbTextCompare) - 1)
        CasePerdanteText = Replace(CasePerdanteText, tempo + ";", "", , 1)
            Letableau.CasePerdant(i) = CLng(tempo)
            i = i + 1
        Wend
        Letableau.CasePerdant_Count = i - 1
        CasePerdanteText = ""
End Sub

'==================================================================================
'
'==================================================================================
Public Sub ImportCouplesPerdants(Letableau As UnTableau)
    Dim tempo As String
    Dim un As String
    Dim deux As String
    Dim i As Long
    
    i = 1
    
    While (Len(CouplePerdantText) > 1) Or i > 40
        tempo = Mid(CouplePerdantText, 1, InStr(1, CouplePerdantText, ";", vbTextCompare) - 1)
        CouplePerdantText = Replace(CouplePerdantText, tempo + ";", "", , 1)
        
        un = Mid(tempo, 1, InStr(1, tempo, ",", vbTextCompare) - 1)
        deux = Replace(tempo, un + ",", "", , 1)
        Letableau.CouplePerdant(i).un = CLng(un)
        Letableau.CouplePerdant(i).deux = CLng(deux)
        
        i = i + 1
    Wend
    Letableau.CouplePerdant_Count = i - 1
    CouplePerdantText = ""
End Sub

'==================================================================================
'   converti le tableau de string d'un tableau en tableau de long
'==================================================================================
Public Sub TransformeEnLong(Letableau As UnTableau)
    Dim i As Long
    Dim j As Long
    
    For i = -10 To 109
        Letableau.Briques(i) = LeVide
    Next i
    
       
    
    For i = 1 To Letableau.Emplacement.Count
        Letableau.Emplacement.Remove 1
    Next i
    
    For i = 0 To 9
        
        For j = 0 To 9
            Select Case Mid(LigneTexte(i), j + 1, 1)
                Case MurTexte
                    Letableau.Briques(i * 10 + j) = UnMur
                Case TrouTexte
                    Letableau.Briques(i * 10 + j) = UnTrou
                    Letableau.Emplacement.Add i * 10 + j
                Case TeteTexte
                    Letableau.Briques(i * 10 + j) = LaTete
                    Letableau.Tete = i * 10 + j
                Case BoiteTexte
                    Letableau.Briques(i * 10 + j) = UneBoite
                Case Trou_TeteTexte
                    Letableau.Briques(i * 10 + j) = UnTrou + LaTete
                    Letableau.Emplacement.Add i * 10 + j
                    Letableau.Tete = i * 10 + j
                Case Trou_BoiteTexte
                    Letableau.Briques(i * 10 + j) = UnTrou + UneBoite
                    Letableau.Emplacement.Add i * 10 + j
                Case VideTexte
                    Letableau.Briques(i * 10 + j) = LeVide
                Case RienTexte
                    Letableau.Briques(i * 10 + j) = Rien
            End Select
        Next j
    Next i
    
End Sub

'==================================================================================
'
'==================================================================================
Public Function NbBoiteBienPlace(Letableau As UnTableau) As Long
    Dim tempo As Long
    Dim i As Long
    For i = 1 To Letableau.Emplacement.Count
        If YaBoite(Letableau.Emplacement.Item(i)) Then
            tempo = tempo + 1
        End If
    Next i
    NbBoiteBienPlace = tempo
End Function

'==================================================================================
'   dessine le tableau une premiere fois
'==================================================================================
Public Sub DessineTout(DansPictureBox As PictureBox, Source As PictureBox, Letableau As UnTableau, Taille As Long)
    Dim i As Long
    Dim j As Long
    
    For i = 0 To 99
        TableauAvant.Briques(i) = Letableau.Briques(i)
        Select Case Letableau.Briques(i)
            Case LeVide
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 0, 0, Taille, Taille
            Case UnMur
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, Taille, 0, Taille, Taille
            Case Rien
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 2 * Taille, 0, Taille, Taille
            Case Rien + Attention
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 4 * Taille, 0, Taille, Taille
            Case UnTrou
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 3 * Taille, 0, Taille, Taille
            Case UnTrou + Attention
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 5 * Taille, 0, Taille, Taille
            Case UneBoite
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 2 * Taille, 2 * Taille, Taille, Taille
            Case LaTete
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 2 * Taille, Taille, Taille, Taille
            Case LaTete + Attention
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 4 * Taille, Taille, Taille, Taille
            Case LaTete + UnTrou
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 3 * Taille, Taille, Taille, Taille
            Case UneBoite + UnTrou
                DansPictureBox.PaintPicture Source.Picture, (i Mod 10) * Taille, (i \ 10) * Taille, Taille, Taille, 3 * Taille, 2 * Taille, Taille, Taille
        End Select
    Next i
    FRMain.BTmoveValue.Caption = LaPartie.Move
    FRMain.BTgoalValue.Caption = CStr(NbBoiteBienPlace(Letableau)) + "/" + CStr(Letableau.Emplacement.Count)
    
End Sub

'==================================================================================
'   redessine les cases qui ont changs
'   on ne redessine jaimais les murs (il ne bouge pas)
'==================================================================================
Public Sub ActualiseAffichage(PICcible As PictureBox)
    Dim i As Long
    For i = 0 To 99
        If TableauActuel.Briques(i) <> TableauAvant.Briques(i) Then
            TableauAvant.Briques(i) = TableauActuel.Briques(i)
            Select Case TableauActuel.Briques(i)
                Case Rien
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 64, 0, 32, 32
                Case UnTrou
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 96, 0, 32, 32
                Case Rien + Attention
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 128, 0, 32, 32
                Case UnTrou + Attention
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 160, 0, 32, 32
                Case UneBoite
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 64, 64, 32, 32
                Case UneBoite + Attention
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 128, 64, 32, 32
                Case LaTete
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 64, 32, 32, 32
                Case LaTete + UnTrou
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 96, 32, 32, 32
                Case LaTete + UnTrou + Attention
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 160, 32, 32, 32
                Case LaTete + Attention
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 128, 32, 32, 32
                Case UneBoite + UnTrou
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 96, 64, 32, 32
                Case UneBoite + UnTrou + Attention
                    PICcible.PaintPicture FRMain.PICsprites.Picture, (i Mod 10) * 32, (i \ 10) * 32, 32, 32, 160, 64, 32, 32
            End Select
        End If
    Next i
    FRMain.BTmoveValue.Caption = CStr(LaPartie.Move)
    FRMain.BTgoalValue.Caption = CStr(NbBoiteBienPlace(TableauActuel)) + "/" + CStr(TableauActuel.Emplacement.Count)
End Sub
